!     #######
SUBROUTINE CLI_LAKE (FG, F)
!     ###############
!
!!****  *CLI_LAKE* - prepares input for lake variables from climate data
!!
!!    PURPOSE
!!    -------
!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!     E. Kourzeneva
!!
!!    MODIFICATIONS
!!    -------------
!!------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!
!
USE MODD_FLAKE_GRID_n, ONLY : FLAKE_GRID_t
USE MODD_FLAKE_n, ONLY : FLAKE_t
!
USE MODI_START_LAKE_OF
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*      0.1    declarations of arguments
!
!
!*      0.2    declarations of local variables
!
!
TYPE(FLAKE_GRID_t), INTENT(INOUT) :: FG
TYPE(FLAKE_t), INTENT(INOUT) :: F
!
INTEGER :: JI
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!-------------------------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CLI_LAKE',0,ZHOOK_HANDLE)

DO JI=1,SIZE(FG%XLAT)
  CALL START_LAKE_OF(F%TTIME%TDATE%DAY,F%TTIME%TDATE%MONTH,FG%XLON(JI),FG%XLAT(JI),&
        F%XWATER_DEPTH(JI), F%XT_SNOW(JI),F%XT_ICE(JI),F%XT_MNW(JI),F%XT_WML(JI), &
        F%XT_BOT(JI),F%XT_B1(JI),F%XCT(JI), &
        F%XH_SNOW(JI),F%XH_ICE(JI),F%XH_ML(JI),F%XH_B1(JI),F%XTS(JI))
 
END DO

IF (LHOOK) CALL DR_HOOK('CLI_LAKE',1,ZHOOK_HANDLE)

END SUBROUTINE CLI_LAKE
